import React from 'react';
import QuizContext from './context';
import QuizQuestions from '../QuizQuestions';
import ResultContainer from '../ResultContainer/ResultContainer';
import { RequestStates } from '../../constants';
import Spinner from '../Spinner/Spinner';
import useQuiz from '../../hooks/useQuiz';
export default function CioQuiz(props) {
    const { cioClient, state, events: { nextQuestion, previousQuestion, resetQuiz, addToCart, resultClick }, } = useQuiz(props);
    const { resultsPageOptions } = props;
    const contextValue = {
        cioClient,
        state,
        nextQuestion,
        previousQuestion,
        resetQuiz,
        addToCart,
        resultClick,
        customClickItemCallback: !!resultsPageOptions?.onQuizResultClick,
    };
    if (state.quiz.requestState === RequestStates.Loading) {
        return (React.createElement("div", { className: 'cio-quiz' },
            React.createElement(Spinner, null)));
    }
    if (state.quiz.requestState === RequestStates.Success) {
        return (React.createElement("div", { className: 'cio-quiz' },
            React.createElement(QuizContext.Provider, { value: contextValue },
                state.quiz.results && React.createElement(ResultContainer, { options: resultsPageOptions }),
                state.quiz.currentQuestion && React.createElement(QuizQuestions, null))));
    }
    return null;
}
